﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Globalization;

namespace Sora.HelpSystem.Editor.Validators
{
    public class PageNameValidationRule : ValidationRule
    {
        public override ValidationResult Validate(object value, CultureInfo cultureInfo)
        {
            var val = value as string;

            if (String.IsNullOrEmpty(val))
                return new ValidationResult(false, "Le nom ne peut pas être vide");
            else if (!Sora.Data.Common.DSPathParser.IsValidNamePath(val))
                return new ValidationResult(false, String.Format("Le nom spécifié n'est pas valide. Il ne peut pas contenir les caractères suivants:\n{0}", Sora.Data.Common.DSPathParser.InvalidPathCharsString));
            else
                return ValidationResult.ValidResult;
        }
    }
}
